/******************************************************************************

  $Header: f:\\RCS\\F\\devel\\pilot\\cppconduit\\LinkSyncConduit\\LinkSyncConduitException.cpp,v 1.3 2002-08-10 20:34:48-04 eshayne Exp eshayne $
  $Revision: 1.3 $
 

  $Log: LinkSyncConduitException.cpp,v $
  Revision 1.3  2002-08-10 20:34:48-04  eshayne
  changed name to Link Synchronizer

  Revision 1.2  2002-07-21 10:24:18-04  eshayne
  added comment and license blocks


	----------------------------------------
    Link Synchronizer
    Copyright (C)2002 Ethan Shayne

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#include "LinkSyncConduitException.h"


LinkSyncConduitException::LinkSyncConduitException(const char* pszFilename, const unsigned long ulLine, const char* pszError, const long lReturnCode)
: mstrFilename(pszFilename),
  mulLine(ulLine),
  mstrError(pszError),
  mlReturnCode(lReturnCode)
{
}


LinkSyncConduitException::LinkSyncConduitException(const LinkSyncConduitException& copy)
: mstrFilename(copy.mstrFilename),
  mulLine(copy.mulLine),
  mstrError(copy.mstrError),
  mlReturnCode(copy.mlReturnCode)
{
}


LinkSyncConduitException& LinkSyncConduitException::operator= (const LinkSyncConduitException& copy)
{
	if (this == &copy)
		return *this;

	mstrFilename = copy.mstrFilename;
	mulLine = copy.mulLine;
	mstrError = copy.mstrError;
	mlReturnCode = copy.mlReturnCode;

	return *this;
}

	
LinkSyncConduitException::~LinkSyncConduitException()
{
}


stlport::string LinkSyncConduitException::GetFullDescription() const
{
	stlport::string strFullDescription = mstrFilename + " at line #";
	char acLineNumberBuffer[1024];
	ultoa(mulLine, acLineNumberBuffer, 10);
	strFullDescription += stlport::string(acLineNumberBuffer);
	strFullDescription += ": " + mstrError;
	char acReturnCodeBuffer[1024];
	ltoa(mlReturnCode, acReturnCodeBuffer, 10);
	strFullDescription += " (return code = " + stlport::string(acReturnCodeBuffer) + ")";

	return strFullDescription;
}


stlport::string LinkSyncConduitException::GetErrorText() const
{
	stlport::string strErr = mstrError;
	char acReturnCodeBuffer[1024];
	ltoa(mlReturnCode, acReturnCodeBuffer, 10);
	strErr += " (return code = " + stlport::string(acReturnCodeBuffer) + ")";

	return strErr;
}


long LinkSyncConduitException::GetReturnCode() const
{
	return mlReturnCode;
}
