/******************************************************************************

  $Header: f:\\RCS\\F\\devel\\pilot\\cppconduit\\LinkSyncConduit\\LinkSyncConduitException.h,v 1.3 2002-08-10 20:34:32-04 eshayne Exp eshayne $
  $Revision: 1.3 $
 

  $Log: LinkSyncConduitException.h,v $
  Revision 1.3  2002-08-10 20:34:32-04  eshayne
  changed name to Link Synchronizer

  Revision 1.2  2002-07-21 10:24:17-04  eshayne
  added comment and license blocks


	----------------------------------------
    Link Synchronizer
    Copyright (C)2002 Ethan Shayne

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#ifndef ES_LINKSYNC_CONDUIT_EXCEPTION
#define ES_LINKSYNC_CONDUIT_EXCEPTION


#include <string>

class LinkSyncConduitException
{
public:
	LinkSyncConduitException(const char* pszFilename, const unsigned long ulLineNumber, const char* pszError, const long lReturnCode = 0);
	LinkSyncConduitException(const LinkSyncConduitException& copy);
	LinkSyncConduitException& operator= (const LinkSyncConduitException& copy);
	virtual ~LinkSyncConduitException();

	stlport::string GetFullDescription() const;
	stlport::string GetErrorText() const;
	long GetReturnCode() const;

private:
	stlport::string mstrFilename;
	unsigned long mulLine;
	long mlReturnCode;
	stlport::string mstrError;
};

#endif