/******************************************************************************

  $Header: f:\\RCS\\f\\devel\\pilot\\cppconduit\\linksyncconduit\\LinkSyncConduitRawData.cpp,v 1.4 2002-08-10 20:34:33-04 eshayne Exp eshayne $
  $Revision: 1.4 $
 

  $Log: LinkSyncConduitRawData.cpp,v $
  Revision 1.4  2002-08-10 20:34:33-04  eshayne
  changed name to Link Synchronizer

  Revision 1.3  2002-07-21 10:24:18-04  eshayne
  added comment and license blocks


	----------------------------------------
    Link Synchronizer
    Copyright (C)2002 Ethan Shayne

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#include "LinkSyncConduitRawData.h"
#include <stdio.h>
#include <assert.h>


LinkSyncConduitRawData::LinkSyncConduitRawData()
: mpImp(NULL)
{
	mpImp = new LinkSyncConduitRawDataImp();
	assert(mpImp);
	mpImp->GetRefCount()++;
}


LinkSyncConduitRawData::LinkSyncConduitRawData(const void* pData, const unsigned short usSize)
: mpImp(NULL)
{
	mpImp = new LinkSyncConduitRawDataImp();
	assert(mpImp);
	mpImp->GetRefCount()++;

	mpImp->SetData(pData, usSize);
}


LinkSyncConduitRawData::LinkSyncConduitRawData(const LinkSyncConduitRawData& copy)
: mpImp(NULL)
{
	mpImp = copy.mpImp;
	if (mpImp)
	{
		mpImp->GetRefCount()++;
	}
}


LinkSyncConduitRawData& LinkSyncConduitRawData::operator= (const LinkSyncConduitRawData& copy)
{
	if (&copy == this)
		return *this;

	if (mpImp)
	{
		if (--mpImp->GetRefCount() == 0)
		{
			delete mpImp;
			mpImp = NULL;
		}
	}

	mpImp = copy.mpImp;
	if (mpImp)
	{
		mpImp->GetRefCount()++;
	}

	return *this;
}


LinkSyncConduitRawData::~LinkSyncConduitRawData()
{
	if (mpImp)
	{
		if (--mpImp->GetRefCount() == 0)
		{
			delete mpImp;
			mpImp = NULL;
		}
	}
}


void LinkSyncConduitRawData::SetData(const void* pData, const unsigned short usSize)
{
	mpImp->SetData(pData, usSize);
}


const void* LinkSyncConduitRawData::GetData() const
{
	assert(mpImp);
	return mpImp->GetData();
}


unsigned short LinkSyncConduitRawData::GetSize() const
{
	assert(mpImp);
	return mpImp->GetSize();
}


unsigned short LinkSyncConduitRawData::GetAllocatedSize() const
{
	assert(mpImp);
	return mpImp->GetAllocatedSize();
}


void LinkSyncConduitRawData::AddData(const void* pData, const unsigned short usAddSize, const bool bNullDelimiter)
{
	assert(mpImp);
	mpImp->AddData(pData, usAddSize, bNullDelimiter);
}


void* LinkSyncConduitRawData::GetData()
{
	assert(mpImp);
	return mpImp->GetData();
}


void LinkSyncConduitRawData::Allocate(const unsigned short usSize)
{
	assert(mpImp);
	mpImp->Allocate(usSize);
}

