/******************************************************************************

  $Header: f:\\RCS\\f\\devel\\pilot\\cppconduit\\linksyncconduit\\LinkSyncConduitRawDataImp.cpp,v 1.4 2002-08-10 20:34:32-04 eshayne Exp eshayne $
  $Revision: 1.4 $
 

  $Log: LinkSyncConduitRawDataImp.cpp,v $
  Revision 1.4  2002-08-10 20:34:32-04  eshayne
  changed name to Link Synchronizer

  Revision 1.3  2002-07-21 10:24:18-04  eshayne
  added comment and license blocks


	----------------------------------------
    Link Synchronizer
    Copyright (C)2002 Ethan Shayne

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#include "LinkSyncConduitRawDataImp.h"
#include <stdio.h>
#include <malloc.h>
#include <memory.h>


LinkSyncConduitRawDataImp::LinkSyncConduitRawDataImp()
: mpData(NULL),
  mulRefCount(0),
  musSize(0),
  musAllocatedSize(0)
{
}


LinkSyncConduitRawDataImp::~LinkSyncConduitRawDataImp()
{
	if (mpData)
	{
		free(mpData);
		mpData = NULL;
		musSize = 0;
		musAllocatedSize = 0;
	}
}


unsigned long& LinkSyncConduitRawDataImp::GetRefCount()
{
	return mulRefCount;
}


unsigned long LinkSyncConduitRawDataImp::GetRefCount() const
{
	return mulRefCount;
}


const void* LinkSyncConduitRawDataImp::GetData() const
{
	return mpData;
}


void* LinkSyncConduitRawDataImp::GetData()
{
	return mpData;
}


void LinkSyncConduitRawDataImp::SetData(const void* pData, const unsigned short usSize)
{
	if (mpData)
	{
		free(mpData);
		mpData = NULL;
		musSize = 0;
		musAllocatedSize = 0;
	}

	try {
		mpData = malloc(usSize);
		musAllocatedSize = usSize;
		memcpy(mpData, pData, usSize);
		musSize = usSize;
	}
	catch (...)
	{
		free(mpData);
		mpData = NULL;
		musSize = 0;
		musAllocatedSize = 0;
		throw;
	}
}


unsigned short LinkSyncConduitRawDataImp::GetSize() const
{
	return musSize;
}


unsigned short LinkSyncConduitRawDataImp::GetAllocatedSize() const
{
	return musAllocatedSize;
}


void LinkSyncConduitRawDataImp::AddData(const void* pData, const unsigned short usAddSize, const bool bNullDelimiter)
{
	if (!mpData)
		SetData(pData, usAddSize);

	void* pTemp = NULL;
	try {
		unsigned short usOffset = 0;
		unsigned short usFinalSize = GetSize() + usAddSize;
		if (bNullDelimiter)
			usFinalSize++;
		pTemp = malloc(usFinalSize);
		memcpy(pTemp, GetData(), GetSize());
		usOffset = GetSize();
		if (bNullDelimiter)
		{
			memcpy((void*)((unsigned long)pTemp + GetSize()), '\0', 1);
			usOffset++;
		}
		memcpy((void*)((unsigned long)pTemp + usOffset), pData, usAddSize);
		usOffset += usAddSize;
		SetData(pTemp, usOffset);
	}
	catch (...)
	{
		free(pTemp);
		throw;
	}
}


void LinkSyncConduitRawDataImp::Allocate(const unsigned short usSize)
{
	if (mpData)
	{
		free(mpData);
		mpData = NULL;
		musSize = 0;
		musAllocatedSize = 0;
	}

	mpData = malloc(usSize);
	musAllocatedSize = usSize;
}



