/******************************************************************************

  $Header: f:\\RCS\\F\\devel\\pilot\\cppconduit\\LinkSyncConduit\\LinkSyncDesktopFavorite.h,v 1.9 2002-09-06 16:43:16-04 eshayne Exp eshayne $
  $Revision: 1.9 $
 

  $Log: LinkSyncDesktopFavorite.h,v $
  Revision 1.9  2002-09-06 16:43:16-04  eshayne
  create subfolders if necessary

  Revision 1.8  2002-08-30 21:45:28-04  eshayne
  - added subfolder support
  - fixed bug in LinkSyncDesktopFavorite::GetAllFavorites(): was leaving file handles open

  Revision 1.7  2002-08-10 20:34:31-04  eshayne
  changed name to Link Synchronizer

  Revision 1.6  2002-07-21 10:24:16-04  eshayne
  added comment and license blocks


	----------------------------------------
    Link Synchronizer
    Copyright (C)2002 Ethan Shayne

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#ifndef ES_LINKSYNC_DESKTOP_FAVORITE
#define ES_LINKSYNC_DESKTOP_FAVORITE

#include <string>
#include <vector>
#include <map>
#include <windows.h>
#include "LinkSyncConduitRawData.h"

#pragma warning(disable : 4786)

class LinkSyncDesktopFavorite
{
public:
	typedef stlport::vector<LinkSyncDesktopFavorite> FavoriteList;
	typedef stlport::map<stlport::string, LinkSyncDesktopFavorite, stlport::less<stlport::string> > FavoriteMap;

	LinkSyncDesktopFavorite();
	LinkSyncDesktopFavorite(const LinkSyncDesktopFavorite& copy);
	LinkSyncDesktopFavorite& operator=(const LinkSyncDesktopFavorite& copy);
	LinkSyncDesktopFavorite(const char* pszName, const char* pszUrl);
	LinkSyncDesktopFavorite(const char* pszPalmDBBuffer);
	LinkSyncDesktopFavorite(const LinkSyncConduitRawData& rawData);
	virtual ~LinkSyncDesktopFavorite();

	bool operator== (const LinkSyncDesktopFavorite& other);
	bool operator< (const LinkSyncDesktopFavorite& other);
	bool operator> (const LinkSyncDesktopFavorite& other);

	const char* GetName() const;
	const char* GetUrl() const;
	const char* GetDirectory() const;
	DWORD GetHHRecordId() const;
	void SetName(const char* pszName);
	void SetUrl(const char* pszUrl);
	void SetDirectory(const char* pszDirectory);
	void SetHHRecordId(const DWORD dwRecordId);

	void ReadFromFile(const char* pszFilename, const char* pszDirectory = NULL);
	void WriteToFile() const;
	DWORD DeleteDesktopFile() const;
	stlport::string GetFilename() const;
	LinkSyncConduitRawData GetPalmDBFormattedData();
	void SetFromPalmDBBuffer(const char* pszPalmDBBuffer);

	static void GetAllFavorites(FavoriteList& colFavorites, const char* pszPath = NULL, const char* pszDiffFromRoot = NULL);
	static void PutFavoritesIntoMap(const FavoriteList& colFavoriteList, FavoriteMap& colFavoriteMap);
	static const char* GetUserFavoritesRootDirectory();


private:
	stlport::string mstrUrl;
	stlport::string mstrName;
	stlport::string* mpstrDirectory;
	DWORD* mpdwHHRecordId;
	LinkSyncConduitRawData* mpPalmDBFormattedData;

	void SetPalmDBFormattedData(const void* pData, unsigned short usSize);
	void CreateDirectoryForFile(const stlport::string& strFullFilename) const;
	void SplitDirectory(const stlport::string& strDirectory, stlport::vector<stlport::string>& colDirectoryPieces) const;
	
	static stlport::string* mgpstrUserFavoritesRootDirectory;
	static void LoadUserFavoritesRootDirectoryFromRegistry();
};

#endif
