/******************************************************************************

  $Header: f:\\RCS\\f\\devel\\pilot\\cppconduit\\linksyncconduit\\LinkSyncDesktopLastState.h,v 1.4 2002-08-10 20:34:31-04 eshayne Exp eshayne $
  $Revision: 1.4 $
 

  $Log: LinkSyncDesktopLastState.h,v $
  Revision 1.4  2002-08-10 20:34:31-04  eshayne
  changed name to Link Synchronizer

  Revision 1.3  2002-07-21 10:24:16-04  eshayne
  added comment and license blocks


	----------------------------------------
    Link Synchronizer
    Copyright (C)2002 Ethan Shayne

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#ifndef ES_LINKSYNC_DESKTOP_LAST_STATE
#define ES_LINKSYNC_DESKTOP_LAST_STATE

#include "LinkSyncDesktopFavorite.h"
#include <string>

#define LINKSYNC_DESKTOP_LASTSTATE_FIELD_DELIMITER '\t'
#define LINKSYNC_DESKTOP_LASTSTATE_RECORD_DELIMITER '\n'

class LinkSyncDesktopLastState
{
public:
	LinkSyncDesktopLastState(const char* pszDirectory);
	LinkSyncDesktopLastState(const char* pszDirectory, const LinkSyncDesktopFavorite::FavoriteList& colFavorites);
	virtual ~LinkSyncDesktopLastState();

	void LoadFromFile();
	void WriteToFile();
	stlport::string GetFullFilename() const;
	LinkSyncDesktopFavorite::FavoriteMap& GetFavorites();
	bool IsEmpty() const;

private:
	LinkSyncDesktopFavorite::FavoriteMap mcolFavorites;
	stlport::string mstrDirectory;

	// disabled
	LinkSyncDesktopLastState(const LinkSyncDesktopLastState&);
	LinkSyncDesktopLastState& operator= (const LinkSyncDesktopLastState&);
};

#endif