/******************************************************************************

  $Header: f:\\RCS\\F\\devel\\pilot\\cppconduit\\LinkSyncConduit\\linksyncconduitgencond.h,v 1.8 2002-08-10 20:34:32-04 eshayne Exp eshayne $
  $Revision: 1.8 $
 

  $Log: linksyncconduitgencond.h,v $
  Revision 1.8  2002-08-10 20:34:32-04  eshayne
  changed name to Link Synchronizer

  Revision 1.7  2002-07-21 10:24:17-04  eshayne
  added comment and license blocks


	----------------------------------------
    Link Synchronizer
    Copyright (C)2002 Ethan Shayne

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

/*****************************************************************************
 *
 * Generic Conduit Export Functions Header File
 *
 ****************************************************************************/


#ifndef  __GENERIC_MAIN_CONDUIT__
#define  __GENERIC_MAIN_CONDUIT__
#include <condapi.h>
#include "LinkSyncDesktopFavorite.h"

#define GENERIC_CONDUIT_VERSION 0x00000102

#ifndef ExportFunc
#ifdef _68K_
#define ExportFunc
#else
#define ExportFunc __declspec( dllexport )
#endif
#endif

extern "C" {

typedef  long (*PROGRESSFN) (char*);
ExportFunc long OpenConduit(PROGRESSFN, CSyncProperties&);
ExportFunc long GetConduitName(char*,WORD);
ExportFunc DWORD GetConduitVersion();
ExportFunc long ConfigureConduit(CSyncPreference& pref);
ExportFunc long GetConduitInfo(ConduitInfoEnum infoType, void *pInArgs, void *pOut, DWORD *dwOutSize);

#ifdef macintosh
	pascal OSErr __initialize(const CFragInitBlock *theInitBlock);
	pascal void __terminate(void);
	pascal OSErr ConduitInit(const CFragInitBlock *theInitBlock);
	pascal void ConduitExit(void);
#endif

}

long SyncPCtoHH(CSyncProperties& rProps);
long SyncHHtoPC(CSyncProperties& rProps);
long SyncMirror(CSyncProperties& rProps);
void LoadAllHandheldRecords(LinkSyncDesktopFavorite::FavoriteList& colFavorites);
void LoadAllHandheldRecords(LinkSyncDesktopFavorite::FavoriteList& colFavorites, BYTE rHandle);
void AddRecordsToHandheld(LinkSyncDesktopFavorite::FavoriteList& colFavorites, BYTE rHandle);
void AddRecordsToHandheld(LinkSyncDesktopFavorite::FavoriteList& colFavorites);
void DeleteRecordsFromHandheld(LinkSyncDesktopFavorite::FavoriteList& colFavorites, BYTE rHandle);
void ChangeRecordsOnHandheld(LinkSyncDesktopFavorite::FavoriteList& colFavorites, BYTE rHandle);
void AddRecordsToDesktop(LinkSyncDesktopFavorite::FavoriteList& colFavorites);
void DeleteRecordsFromDesktop(LinkSyncDesktopFavorite::FavoriteList& colFavorites, const bool bContinueIfError);
void ChangeRecordsOnDesktop(LinkSyncDesktopFavorite::FavoriteList& colFavorites);
BYTE OpenDB(const bool bCreateIfNeeded = true);
void CloseDB(BYTE rHandle, const bool bThrowException);
void CompareRecords(const LinkSyncDesktopFavorite::FavoriteMap& colPCFavoriteMap,
					const LinkSyncDesktopFavorite::FavoriteMap& colPCLastStateFavoriteMap,
					const LinkSyncDesktopFavorite::FavoriteMap& colHHFavoriteMap,
					LinkSyncDesktopFavorite::FavoriteList& colAddToHH,
					LinkSyncDesktopFavorite::FavoriteList& colAddToPC,
					LinkSyncDesktopFavorite::FavoriteList& colDeleteFromHH,
					LinkSyncDesktopFavorite::FavoriteList& colDeleteFromPC,
					LinkSyncDesktopFavorite::FavoriteList& colChangeOnHH,
					LinkSyncDesktopFavorite::FavoriteList& colChangeOnPC,
					LinkSyncDesktopFavorite::FavoriteList& colPCNewLastState);
void UpdateDesktopLastStateFile(CSyncProperties& rProps, const LinkSyncDesktopFavorite::FavoriteList& colPCFavorites);

#endif


