/******************************************************************************

   $Revision: 1.4 $
   $Header: f:\\RCS\\F\\devel\\pilot\\CodeWarrior\\LinkSync\\Src\\LinkSync.h,v 1.4 2002-08-10 20:33:40-04 eshayne Exp eshayne $
   $Log: LinkSync.h,v $
   Revision 1.4  2002-08-10 20:33:40-04  eshayne
   changed name to Link Synchronizer

   Revision 1.3  2002-07-21 10:23:38-04  eshayne
   added comment and license blocks

   Revision 1.2  2002-04-03 19:50:23-05  eshayne
   started working on edit

   Revision 1.1  2002-03-31 17:37:18-05  eshayne
   handles adds, but no auto-update, no edit, no sync, no delete...

	----------------------------------------
    Link Synchronizer
    Copyright (C)2002 Ethan Shayne

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#ifndef LINKSYNC_H_
#define LINKSYNC_H_

/*********************************************************************
 * Internal Structures
 *********************************************************************/

typedef struct LinkSyncPreferenceType
{
	UInt8 replaceme;
} LinkSyncPreferenceType;

enum AddFormMode {ADD, EDIT, DELETE};

/*********************************************************************
 * Global variables
 *********************************************************************/

extern LinkSyncPreferenceType g_prefs;
extern DmOpenRef g_dbRef;

/*********************************************************************
 * Internal Constants
 *********************************************************************/

#define appFileCreator			'LSnc'
#define appName					"LinkSync"
#define appVersionNum			0x01
#define appPrefID				0x00
#define appPrefVersionNum		0x01

/*********************************************************************
 * Helper template functions
 *********************************************************************/

/* use this template like:
 * ControlType *button; GetObjectPtr(button, MainOKButton); */

template <class T>
void GetObjectPtr(typename T * &ptr, UInt16 id)
{
	FormType * frmP;

	frmP = FrmGetActiveForm();
	ptr = static_cast<T *>(
		FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, id)));
}

/* use this template like:
 * ControlType *button = 
 *     GetObjectPtr<ControlType>(MainOKButton); */

template <class T>
typename T * GetObjectPtr(UInt16 id)
{
	FormType * frmP;

	frmP = FrmGetActiveForm();
	return static_cast<T *>(
		FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, id)));
}

#endif /* LINKSYNC_H_ */
